/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* CON_VIWS.H                                                */
/*************************************************************/

#include <strstrea.h>
#include <string.h>
#ifndef BOOLEAN
#define BOOLEAN
enum Boolean { false, true };
#endif

#ifndef CON_VIWS_H
#define CON_VIWS_H

const MAX_CONSOLE_MENU_SIZE = 10;

class Console_Menu {
public:

	// Constructors/destructors
	Console_Menu() { menu_size = 0; }
	~Console_Menu() { }

	// Implementors
	void add_item(char* new_item);
	void add_terminator(char* quit_label);
	void add_prompt(char* menu_prompt);

	void display_menu();
	int get_user_selection();

	// Accessors
	int get_selection() { return selection; }

protected:

	Boolean validate_selection(int selection);

	// Data members
	char* menu_items[MAX_CONSOLE_MENU_SIZE];
	char* prompt_string;
	int menu_size;
	int selection;
};



class Console_Display_Box {
public:

	// Constructors/destructors
	Console_Display_Box() { label_string = ""; }
	~Console_Display_Box() { }

	// Accessors
	char* get_label_string() { return label_string; }
	void set_label_string(char* a_string)
		{ label_string = a_string; }

protected:

	void display_label_string();

private:

	// Data members
	char* label_string;
};

#endif