/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* COUNT1.H                                                  */
/*************************************************************/

#ifndef COUNT1_H
#define COUNT1_H


template<class Count_Type>
class Count {
public:

	// Constructors/destructors
	Count() { }
	virtual ~Count() { }

	// Implementors
	virtual void increment() = 0;
	virtual void decrement() = 0;
	void reset(){value = reset_value;}

	// Accessors
	Count_Type get_value() { return value; }
	void set_value(Count_Type new_value) { value =
		new_value; }

	Count_Type get_reset_value() { return reset_value; }
	void set_reset_value(Count_Type new_value) { value =
		new_value; }

protected:

	// Data members
	Count_Type value;
	Count_Type reset_value;
};

class Integer_Count : public Count<int> {
public:

	// Constructors/destructors
	Integer_Count() { reset_value = 0; reset(); }
	Integer_Count(int new_value)
		{ reset_value = 0; value = new_value; }
	~Integer_Count() { }

	// Implementors
	void increment();
	void decrement();
	char* asBase(int number_base);
};
#endif
