/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* COUNT3.CPP                                                */
/*************************************************************/

#include <iostream.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#ifndef COUNT3_H
#include "count3.h"
#endif

// Integer_Count member functions

void Integer_Count::increment()
{
	value++;
}

void Integer_Count::decrement()
{
	value--;
}


char* Integer_Count::asBase(int new_base)
{
	char answer_string[80];
	char partial_answer_string[80];
	char remainder_string[10];
	int quotient;
	int remainder;

	remainder = value % new_base;
	quotient = quotient / new_base;
	itoa(remainder, remainder_string, new_base);
	strcpy(answer_string, remainder_string);
	while(quotient != 0)
	{
		remainder = quotient % new_base;
		quotient = quotient / new_base;
		itoa(remainder, remainder_string, new_base);
		strcpy(partial_answer_string, remainder_string);
		strcat(partial_answer_string, answer_string);
		strcpy(answer_string, partial_answer_string);
	}
	return answer_string;
}

// ASCII_Count member functions

void ASCII_Count::increment()
{
	value++;

	// Handle wraparound
	if (toascii(value) > MAX_ASCII_VALUE)
			value = (char) MIN_ASCII_VALUE;
}

void ASCII_Count::decrement()
{
	value--;

	// Handle wraparound
	if (toascii(value) < MIN_ASCII_VALUE)
			value = (char) MAX_ASCII_VALUE;
}

// Date Count member functions

void Date_Count::increment()
{
	value++;
}

void Date_Count::decrement()
{
	value--;
}

char* Date_Count::get_display_value()
{
	return value.print_string();
}
