/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* COU_VWS2.H                                                */
/*************************************************************/

#include <iostream.h>
#ifndef CON_VIWS_H
#include "con_viws.h"
#endif
#ifndef COUNTS_H
#include "counts.h"
#endif
#ifndef BOOLEAN
#define BOOLEAN
enum Boolean { false, true };
#endif

#ifndef COU_VWS2_H
#define COU_VWS2_H

template<class Count_Type>
class Count_Console_Menu : public Console_Menu {
public:
	// Constructors/destructors
	Count_Console_Menu() { }
	~Count_Console_Menu() { }

	// Implementors
	void execute_selection();
	void make_items(Count_Type& a_count);

	// Accessors
	Count_Type& get_count() { return *count;}
	void set_count(Count_Type& a_count) { count = &a_count; }

private:

	// Data members
	Count_Type* count;
};

template<class Count_Type>
class Count_Console_Display_Box : public
	Console_Display_Box {
public:

	// Constructors/destructors
	Count_Console_Display_Box() { }
	~Count_Console_Display_Box() { }

	// Implementors
	void display_value();

	// Accessors
	Count_Type& get_count() { return *count; }
	void set_count(Count_Type& a_count) { count = &a_count; }

private:

	// Data members
	Count_Type* count;
};

// Template function bodies for Count_Console_Menu.
// The compiler must see the actual definition of a template
// function, not just its prototype, in order to instantiate it.

template<class Count_Type>
void Count_Console_Menu<Count_Type>
	::make_items(Count_Type& a_count)
{
	this->add_item("Increment");
	this->add_item("Decrement");
	this->add_item("Reset");
	count = &a_count;
}

template<class Count_Type>
void Count_Console_Menu<Count_Type>::execute_selection()
{
	switch (selection) {
		case 1:
			count->increment();
			break;
		case 2:
			count->decrement();
			break;
		case 3:
			count->reset();
			break;
	};
}

// Template functions for Count_Console_Display_Box
// The compiler must see the actual definition of a template
// function, not just its prototype, in order to instantiate it.

template<class Count_Type>
void Count_Console_Display_Box<Count_Type>
	::display_value()
{
	cout << this->get_label_string()
	     << count->get_value()
	     << endl;
}

#endif
