/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* CVWCNTR.CPP                                               */
/*************************************************************/

#ifndef CVWCNTR_H
#include "cvwcntr.h"
#endif
#ifndef COUNTS_H
#include "counts.h"
#endif

void Count_View_Container::display_count_views
	(int initial_value)
{
	// Create and initialize an integer count.
	Integer_Count an_integer_count(initial_value);

	// Create a console menu and display box.
	Count_Console_Menu menu;
	Count_Console_Display_Box display_box;

	// Customize the menu for integer count.
	menu.make_items(an_integer_count);
	menu.add_terminator("Quit");
	menu.add_prompt("Make a selection:  ");

	// Customize the display box for the integer count.
	display_box.set_count(an_integer_count);
	display_box.set_label_string("Current Value:  " );

	// Display the count views.
	display_box.display_value();

	while (menu.get_user_selection() != 0)
		{
		menu.execute_selection();
		display_box.display_value();
		}
}
