/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* DATE.H                                                    */
/*************************************************************/

#include <time.h>
#include <strstrea.h>
#ifndef DATE_H
#define DATE_H


enum Weekday { sun = 1, mon = 2, tue = 3, wed = 4,
		 thu = 5, fri = 6, sat = 7 };


class Date  {
public:

	// Constructors/destructors
	Date();
	Date(int day, int month, int year);
	~Date() { }

	// Implementors
	void set_date(int day, int month, int year);
	char* print_string();

	Weekday day_of_week();
	int day_of_month();
	int month();
	int year();

	// Operators
	Date operator++(); 	// prefix
	Date operator++(int);	// postfix

	Date operator--(); 	// prefix
	Date operator--(int);	// postfix

	friend int operator< (Date& date1, Date& date2);
	friend int operator> (Date& date1, Date& date2);
	friend int operator== (Date& date1, Date& date2);

	friend ostream& operator<< (ostream& os, Date& a_date);

private:
	time_t calendar_time;
	static long seconds_per_day;
};

#endif
