/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* TEST8.CPP                                                 */
/*************************************************************/

#include <iostream.h>
#include <ctype.h>
#ifndef CVWCNTR2_H
#include "cvwcntr2.h"
#endif

int main()
{

	// Create views for various types of counts.
	Count_View_Container <Integer_Count, int>
				 integer_count_container;

	Count_View_Container <ASCII_Count, char>
				 ascii_count_container;

	Count_View_Container <Date_Count, Date>
				 date_count_container;

	Count_View_Container <Sequence_Count, char**>
				 sequence_count_container;

	// Demo the various types of counts.
	cout << endl << "INTEGER demo"  << endl << endl;
	integer_count_container.display_count_views(10);

	cout << endl << "ASCII demo"  << endl << endl;
	ascii_count_container.display_count_views('k');

	cout << endl << "DATE demo"  << endl << endl;
	date_count_container.display_count_views(Date());

	cout << endl << "Sequence demo"  << endl << endl;
	char* color_sequence[MAX_SEQUENCE_SIZE] =
		{"white", "yellow", "orange", "red", "green",
		"blue", "violet", "black"};
	sequence_count_container.display_count_views
		(color_sequence);

	cout << endl << "Happy trails." << endl;

	return 0;
}