/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* CON_VIWS.CPP                                              */
/*************************************************************/

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#ifndef CON_VIWS_H
#include "con_viws.h"
#endif


// Member functions for Console_Menu

void Console_Menu::display_menu()
{
	cout << endl;
	for (int i = 0; i < menu_size; i++) {
		cout << menu_items[i] << endl;
	}
	cout << endl << prompt_string;
}

void Console_Menu::add_item(String new_item)
{
	menu_items[menu_size] =
		String(menu_size + 1) + String(". ") + new_item;
	menu_size++;
}

void Console_Menu::add_prompt(String new_prompt)
{
	prompt_string = new_prompt;
}

void Console_Menu::add_terminator(String quit_label)
{
	this->add_item(quit_label);
}

int Console_Menu::get_user_selection()
{
	int choice, quit_choice = menu_size ;
	char choice_char;
	Boolean valid_selection = false;

	while (!valid_selection)
	{
	this->display_menu();
	// Read the first character; ignore the rest.
	cin.get(choice_char);
	cin.ignore(100, '\n');
	// Convert the character to an integer.
	if (!isdigit(choice_char))
		choice = 0;
	else
		choice = atoi(&choice_char);
	// Check if the choice is valid.
	if (!this->validate_selection(choice))
		cout << "Invalid choice, try again." << endl;
	else
		valid_selection = true;
	}
	// Set the selection and return it.
	if (choice == quit_choice)
		selection = 0;
	else
		selection = choice;
	return selection;
}

Boolean Console_Menu::validate_selection(int user_selection)
{
	if ((user_selection <= menu_size) && (user_selection > 0))
		return true;
	else
		return false;
}

void Console_Display_Box::display_label_string()
{
	cout << endl << label_string;
}
