/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* CSH_VWS2.CPP                                              */
/*************************************************************/

#include <stdio.h>
#include<string.h>
#ifndef CASH_VWS_H
#include "cash_vws.h"
#endif


//Cash_Device_Console_Display_Box Member functions

void Cash_Device_Console_Display_Box::display_value()
{
	float amount;

	amount = a_cash_device->get_amount_collected();
	this->display_label_string();
	cout << amount;
}

//Cash_Device_Console_Menu Member functions

void Cash_Device_Console_Menu::make_items
	(Cash_Device& new_device)
{
		a_cash_device = &new_device;
		this->add_item("Add money (0.25): ");
		this->add_item("Return money ");
}

void Cash_Device_Console_Menu::execute_selection()
{
	switch (selection)
	{
		case 1:
			a_cash_device->add_cash(0.25);
			break;
		case 2:
			a_cash_device->return_cash();
			break;
	};

}

//Cash_Device_View_Container member functions

void Cash_Device_View_Container::
	make_cash_device_menu(Cash_Device&
	a_cash_device)
{
	cash_device_menu = new Cash_Device_Console_Menu();
	cash_device_menu->make_items(a_cash_device);
	cash_device_menu->add_terminator("Done");
	cash_device_menu->add_prompt("Enter cash, please:  ");
}

void Cash_Device_View_Container::make_amount_box
		(Cash_Device& a_cash_device)
{
	amount_box = new Cash_Device_Console_Display_Box();
	amount_box->set_cash_device(a_cash_device);
	amount_box->set_label_string("Amount entered: ");
}


void Cash_Device_View_Container::build_views
		(Cash_Device& a_cash_device)
{
	this->make_amount_box(a_cash_device);
	this->make_cash_device_menu(a_cash_device);
}

void Cash_Device_View_Container::display_components()
{
	while (cash_device_menu->get_user_selection())
		{
		cash_device_menu->execute_selection();
		amount_box->display_value();
		}

}

