/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* CSH_VWS2.H                                                */
/*************************************************************/

#include <iostream.h>
#ifndef CON_VIWS_H
#include "con_viws.h"
#endif
#ifndef VENDING_H
#include "vending.h"
#endif
#ifndef BOOLEAN
#define BOOLEAN
enum Boolean { false, true };
#endif

#ifndef CSH_VWS2_H
#define CSH_VWS2_H


class Cash_Device_Console_Display_Box : public
	Console_Display_Box {
public:

	// Constructors/destructors
	Cash_Device_Console_Display_Box() { }
	~Cash_Device_Console_Display_Box() { }

	// Implementors
	void display_value();

	// Accessors
	Cash_Device& get_cash_device() { return *a_cash_device; }
	void set_cash_device(Cash_Device& new_device)
		{ a_cash_device = &new_device; }

private:

	// Data members
	Cash_Device* a_cash_device;
};


class Cash_Device_Console_Menu : public Console_Menu {
public:

	// Constructors/destructors
	Cash_Device_Console_Menu() { }
	~Cash_Device_Console_Menu() { }

	// Implementors
	void make_items(Cash_Device& cash_device);
	void execute_selection();

	// Accessors
	Cash_Device& get_cash_device() { return *a_cash_device; }
	void set_cash_device(Cash_Device& new_device)
			{a_cash_device = &new_device;}

private:

	// Data members
	Cash_Device* a_cash_device;
};

class Cash_Device_View_Container {
public:

	// Constructors/destructors
	Cash_Device_View_Container(){ }
	~Cash_Device_View_Container(){ }

	//Implementors
	void build_views(Cash_Device& a_cash_device);
	void make_amount_box(Cash_Device& a_cash_device);
	void make_cash_device_menu
		(Cash_Device& a_cash_device);

	void display_components();

private:

	Cash_Device_Console_Display_Box* amount_box;
	Cash_Device_Console_Menu* cash_device_menu;
};

#endif

