/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* ITEM_MNU.CPP                                              */
/*************************************************************/

#include <stdio.h>
#include<string.h>
#ifndef ITEM_MNU_H
#include "item_mnu.h"
#endif

//Item_Console_Menu Member functions

void Item_Console_Menu::make_items(Dispensing_Holder** dispensing_holders,
				    int number_of_holders)
{
	Dispensing_Holder* a_dispensing_holder;

	// For each dispensing holder, add its dispenable
	// item name to the menu.
	for (int i = 0; i < number_of_holders; i++)
		{
		a_dispensing_holder = dispensing_holders[i];
		String name =
			a_dispensing_holder->dispensable_item_name();
		this->add_item(name);
		}
	this->set_dispensing_holders(dispensing_holders,
			number_of_holders);
}

void Item_Console_Menu::set_dispensing_holders
			(Dispensing_Holder** new_value,
				int number_of_holders)
{
	for (int i = 0; i < number_of_holders; i++)
		dispensing_holders[i] = new_value[i];
}

void Item_Console_Menu::execute_selection()
{
	Dispensing_Holder* a_dispensing_holder =
			 dispensing_holders[selection-1];

	a_dispensing_holder->vend_the_dispensable_item();
	this->update_items();
}


void Item_Console_Menu::replace_item(String new_item,
	int item_number)
{
	menu_items[item_number] =
		String(item_number + 1) + String(". ") +
		new_item;
}

void Item_Console_Menu::update_item(int item_number)
{
	Dispensing_Holder* a_dispensing_holder;
	a_dispensing_holder = dispensing_holders[item_number];
	String name = a_dispensing_holder->
		dispensable_item_name();
	this->replace_item(name, item_number);
}

void Item_Console_Menu::update_items()
{
	if(selection == 0)
		return;
	this->update_item(selection - 1);
}


Boolean Item_Console_Menu:: sold_out_selection()
{
	if (dispensing_holders[selection-1]->is_empty())
		return true;
	else
		return false;
}



