/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* ITEM_VWS.CPP                                              */
/*************************************************************/

#ifndef ITEM_VWS_H
#include "item_vws.h"
#endif


// Item_Console_Display_Box member functions

String Item_Console_Display_Box::get_dispensable_name()
{
	String name =
		a_dispensing_holder->dispensable_item_name();
	return name;
}

String Item_Console_Display_Box::get_dispensable_price()
{
	float price = a_dispensing_holder->
		dispensable_item_price();
	// Create a string from a float.
	String price_string(price);
	return price_string;
}

String Item_Console_Display_Box::get_value()
{
	if (display_flag == String("price"))
		return(this->get_dispensable_price());
	else
		return(this->get_dispensable_name());
}

void Item_Console_Display_Box::display_value()
{
	cout << this->get_value();
}

//Item_View_Container member functions

void Item_View_Container::make_name_box
		(Dispensing_Holder& a_dispensing_holder)
{
	name_box = new Item_Console_Display_Box();
	name_box->set_dispensing_holder(a_dispensing_holder);
	name_box->set_display_flag_to_name();
}

void Item_View_Container::make_price_box
		(Dispensing_Holder& a_dispensing_holder)
{
	price_box = new Item_Console_Display_Box();
	price_box->set_dispensing_holder(a_dispensing_holder);
	price_box->set_display_flag_to_price();
}

void Item_View_Container::build_views
		(Dispensing_Holder& a_dispensing_holder)
{
	this->make_name_box(a_dispensing_holder);
	this->make_price_box(a_dispensing_holder);
}

void Item_View_Container::display_components()
{

	char* border = "--------------------------";
	cout << border;
	cout << endl;
	name_box->display_value();
	cout << "\t";
	price_box->display_value();
	cout << endl << border<< endl;
}
