/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* ITEM_VWS.H                                                */
/*************************************************************/

#include <iostream.h>
#ifndef CON_VIWS_H
#include "con_viws.h"
#endif
#ifndef VENDING_H
#include "vending.h"
#endif
#ifndef BOOLEAN
#define BOOLEAN
enum Boolean { false, true };
#endif

#ifndef ITEM_VWS_H
#define ITEM_VWS_H


class Item_Console_Display_Box : public Console_Display_Box {
public:

	// Constructors/destructors
	Item_Console_Display_Box() {display_flag =
		String("name"); }
	~Item_Console_Display_Box() { }

	// Implementors
	void display_value();
	String get_value();

	void set_display_flag_to_name(){ display_flag =
		String("name");}
	void set_display_flag_to_price(){ display_flag =
		String("price");}

	String get_dispensable_price();
	String get_dispensable_name();

	// Accessors
	void set_dispensing_holder(Dispensing_Holder&
		new_holder)
			{ a_dispensing_holder = &new_holder; }
	Dispensing_Holder& get_dispensing_holder()
			{ return *a_dispensing_holder; }

private:

	// Data members
	Dispensing_Holder* a_dispensing_holder;
	String display_flag;
};


class Item_View_Container {
public:

	// Constructors/destructors
	Item_View_Container(){ }
	~Item_View_Container(){ }

	//Implementors
	void build_views(Dispensing_Holder&
		a_dispensing_holder);
	void make_price_box(Dispensing_Holder&
		a_dispensing_holder);
	void make_name_box(Dispensing_Holder&
		a_dispensing_holder);
	void display_components();

private:

	Item_Console_Display_Box* price_box;
	Item_Console_Display_Box* name_box;

};

#endif