/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* VEND1.H                                                   */
/*************************************************************/

#include "string.h"
#ifndef BOOLEAN
#define BOOLEAN
enum Boolean { false, true };
#endif

#ifndef VEND1_H
#define VEND1_H

const MAX_ITEMS_SIZE = 10;

// Forward declarations
class Dispensing_Holder;

class Item {
public:

	// Constructors/destructors
	Item() { price = 0.0;}
	Item(String new_name, float new_price)
			{name = new_name; price = new_price;}
	~Item() { }

	// Implementors
	Boolean vend();

	// Accessors
	String& get_name() { return name; }
	void set_name(String& new_name) { name = new_name; }

	float get_price() { return price; }
	void set_price(float new_price) { price = new_price; }

	Dispensing_Holder& get_dispensing_holder()
		{ return *a_dispensing_holder; }
	void connect_to_dispensing_holder
		(Dispensing_Holder& new_holder)
			{ a_dispensing_holder =  &new_holder; }

	// Overloaded operators for Items
	Boolean operator== (Item& an_item);
	friend ostream& operator<< (ostream& os, Item& an_item);

private:

	// Data members
	String name;
	float price;
	Dispensing_Holder* a_dispensing_holder;
};

class Dispensing_Holder {
public:

	// Constructors/destructors
	Dispensing_Holder() { item_index = 0; }
	~Dispensing_Holder() { }

	//Implementors: Testing
	Boolean is_empty();
	Boolean item_is_dispensable(Item& item_to_dispense);

	//Implementors: Dispensing
	Boolean dispense(Item& item_to_dispense);
	void activate_dispenser();
	void print_item(Item& item_to_dispense);

	// Accessors
	Item** get_items() { return items; }
	Boolean connect_to_item(Item& new_item);
	Boolean disconnect_with_item(Item& new_item);

private:

	// Data members
	Item* items[MAX_ITEMS_SIZE];
	int item_index;

};

#endif