/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* VEND2.CPP                                                 */
/*************************************************************/

#include <iostream.h>
#ifndef VEND2_H
#include "vend2.h"
#endif

// Cash_Device member functions

Boolean Cash_Device::got_enough(float amount_to_collect)
{
	if (amount_collected >= amount_to_collect)
		return true;
	else
		return false;
}

float Cash_Device::make_change(float item_price)
{
	amount_collected -= item_price;
	return amount_collected;

}

float Cash_Device::return_cash()
{
	float return_amount = amount_collected;
	amount_collected = 0;
	return return_amount;
}


void Cash_Device::add_cash(float cash_amount)
{
	amount_collected += cash_amount;
}

// Item member functions and operators

Boolean Item::vend()
{
	Boolean success;

	success = a_dispensing_holder->dispense(*this);
	return success;
}

Boolean Item::operator== (Item& an_item)
{
	if ((name == an_item.get_name()) &&
	    (price == an_item.get_price()))
		return true;
	else
		return false;
}

ostream& operator<< (ostream& os, Item& an_item)
{
	String& item_name = an_item.name;
	os << item_name << " price:  "
		<< an_item.get_price();
	return os;
}


// Dispensing_Holder member functions and operators

Boolean Dispensing_Holder::connect_to_item(Item& an_item)
{
	if (item_index < MAX_ITEMS_SIZE)
	   {
		this->items[item_index++] = &an_item;
		return true;
	   }
	return false;
}

Boolean Dispensing_Holder::disconnect_with_item(Item& an_item)
{
	for (int i = 0; i < item_index; i++)
		if (*(this->items[i]) == an_item)
		   {
			for (int j = i; j < (item_index-1); j++)
				this->items[j] = this->items[j+1];
			item_index--;
			return true;
		   }
	return false;
}

Boolean Dispensing_Holder::is_empty()
{
	if (item_index == 0)
		return true;
	else
		return false;
}


Boolean Dispensing_Holder::item_is_dispensable(Item&
	   item_to_dispense)
{
	if (*(items[0]) == item_to_dispense)
		return true;
	else
		return false;
}

void Dispensing_Holder::activate_dispenser()
{
	// no-op for simulation purposes
}

void Dispensing_Holder::print_item(Item& item_to_dispense)
{
	cout << endl << "Releasing item:  "
		<< item_to_dispense << endl;
}

Boolean Dispensing_Holder::dispense(Item& item_to_dispense)
{
	if (this->is_empty())
		return false;
	if (!this->item_is_dispensable(item_to_dispense))
		return false;

	this->activate_dispenser();
	this->print_item(item_to_dispense);
	this->disconnect_with_item(item_to_dispense);
	return true;
}

