/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* VMCHNCTR.H                                                */
/*************************************************************/

#ifndef VEND_VWS_H
#include "vend_vws.h"
#endif
#ifndef VENDING_H
#include "vending.h"
#endif

#ifndef VMCHNCTR_H
#define VMCHNCTR_H

const MAX_CONTAINER_SIZE = 15;

//Vending_Machine_View_Container

class Vending_Machine_View_Container {
public:

	// Constructors/destructors
	Vending_Machine_View_Container()
		{ component_count = -1; }
	~Vending_Machine_View_Container() { }

	//Implementors

	 // View builders
	void build_view_containers(Dispensing_Holder**
		dispensing_holders, Cash_Device& a_cash_device,
		int number_of_holders);
	void make_cash_device_view_container
			(Cash_Device& a_cash_device);
	void make_item_view_container
			(Dispensing_Holder& dispensing_holder);
	void make_item_menu
			(Dispensing_Holder** dispensing_holders,
			int number_of_holders);

	// Displaying
	void display_components();
	void display_item_view_containers();

	// Demos
	void vending_machine_demo();
	void vending_machine_demo(Dispensing_Holder**
		dispensing_holders, Cash_Device& a_cash_device,
		int number_of_holders);

private:

	// Data members
	Item_Console_Menu* menu;
	Item_View_Container*
		item_view_containers[MAX_CONTAINER_SIZE];
	Cash_Device_View_Container* a_cash_device_view_container;
	int component_count;

};

#endif