/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* CC_BOOLE.H                                                */
/*************************************************************/

#ifndef CC_BOOLE_H
#define CC_BOOLE_H

class Boolean {
public:

	Boolean() { truth_value = 0; }
	Boolean(Boolean& a_boolean)
		{ truth_value = a_boolean.is_true(); }
	Boolean (int an_integer) { truth_value =
		(an_integer != 0); }
	~Boolean() { }

	int be_true() { truth_value = 1; return truth_value; }
	int be_false() { truth_value = 0; return truth_value; }

	int is_true() { return (truth_value != 0); }
	int is_false() { return (truth_value == 0); }

	int operator! () { return !truth_value; }
	operator int () { return truth_value; }

	friend ostream& operator<< (ostream& os, Boolean& a_boolean);

private:

	int truth_value;
};

inline ostream& operator<< (ostream& os, Boolean& a_boolean)
{
	if(!a_boolean)
		os << "false";
	else
		os << "true";
	return os;
}

const false = Boolean(0);
const true = Boolean(1);

#endif