/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* CSTM_WIN.CPP                                              */
/*************************************************************/

#ifndef CSTM_WIN_H
#include "cstm_win.h"
#endif

void Customer_Window::make_customer_container
	(Customer& a_customer,
	Transaction_Selection_Holder* a_transaction_holder)
{
	a_customer_container = new Customer_Container();
	a_customer_container->build_views(a_customer);
	a_customer_container->
		connect_menu_to_holder(*a_transaction_holder);
	a_transaction_holder->connect_to_customer(a_customer);
}

void Customer_Window::make_transaction_container
	(Transaction_Selection_Holder* a_transaction_holder,
	Line_Item_Selection_Holder* a_line_item_holder)
{
	a_transaction_container = new Transaction_Container;

	a_transaction_container->build_views();
	a_transaction_holder->
		connect_to_transaction_container
			(*a_transaction_container);
	a_transaction_container->
		connect_to_line_item_selection_holder
			(*a_line_item_holder);
}

void Customer_Window::make_line_item_container
		(Line_Item_Selection_Holder* a_line_item_holder)
{
	a_line_item_container = new Line_Item_Container();
	a_line_item_container->build_views();
	a_line_item_holder->
		connect_to_line_item_container
			(*a_line_item_container);
}

void Customer_Window::build_views(Customer& a_customer)
{
	Transaction_Selection_Holder* a_transaction_holder =
		new Transaction_Selection_Holder();
	Line_Item_Selection_Holder* a_line_item_holder =
		new Line_Item_Selection_Holder();

	this->make_customer_container(a_customer,
		a_transaction_holder);
	this->make_transaction_container(a_transaction_holder,
		a_line_item_holder);
	this->make_line_item_container(a_line_item_holder);
}



void Customer_Window::display_components()
{
	a_customer_container->display_components();
}

