/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* CSTM_WIN.H                                                */
/*************************************************************/

#include <iostream.h>
#ifndef TRN_VWS5_H
#include "trn_vws5.h"
#endif
#ifndef SALES_H
#include "sales.h"
#endif

#ifndef CSTM_WIN_H
#define CSTM_WIN_H

class Customer_Window {
public:

	// Constructors/destructors
	Customer_Window() { }
	~Customer_Window() { }

	// Implementors
	void make_customer_container
			(Customer& a_customer,
			Transaction_Selection_Holder*
				a_transaction_holder);
	void make_transaction_container
			(Transaction_Selection_Holder*
				a_transaction_holder,
			Line_Item_Selection_Holder*
				a_line_item_holder);
	void make_line_item_container
			(Line_Item_Selection_Holder*
				a_line_item_holder);
	void build_views(Customer& a_customer);
	void display_components();

private:

	// Data members
	Customer_Container* a_customer_container;
	Transaction_Container* a_transaction_container;
	Line_Item_Container* a_line_item_container;
};

#endif