/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* SALES1.H                                                  */
/*************************************************************/

#include <iostream.h>
#include <strstrea.h>
#include "time.h"
#include "date.h"
#include "cc_boole.h"
#include "olist.h"
#include "string.h"


#ifndef SALES1_H
#define SALES1_H


class Product {
public:

	// Constructors/destructors
	Product();
	Product(String a_name, float a_price);
	~Product() { }

	// Accessors
	String get_name() { return name; }
	void set_name(String new_value) { name = new_value; }

	float get_price() { return price; }
	void set_price(float new_value) { price = new_value; }

	friend ostream& operator<<(ostream& os, Product& a_product);
	Boolean operator==(Product& a_product);

private:

	// Data members
	String name;
	float price;
};


class Line_Item {
public:

	// Constructors/destructors
	Line_Item() { quantity = 0; line_number = 0;}
	Line_Item(Product& a_product, int product_quantity);
	~Line_Item() { }

	// Implementors
	float calculate_total();

	// Accessors
	int get_quantity() { return quantity; }
	void set_quantity(int new_value) { quantity =
		new_value; }

	int get_line_number() { return line_number; }
	void set_line_number(int new_value)
		{ line_number = new_value; }

	Product& get_product() { return *product; }
	void connect_to_product(Product& a_product);

	// Overloaded operators for Line_Items
	Boolean operator== (Line_Item& a_transaction_line_item);
	friend ostream& operator<< (ostream& os, Line_Item&
						 a_transaction_line_item);

private:

	// Data members
	Product* product;
	int line_number;
	int quantity;
};


#endif