/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* TEST12.CPP                                                */
/*************************************************************/

#ifndef SALES_H
#include "sales.h"
#endif

#ifndef FORMATS_H
#include "formats.h"
#endif

int main ()
{
	// Create the demo customer.
	Customer customer;
	Customer& mr_rubble = customer.customer_demo();

	// Create an object table and its sales class map.
	Object_Table an_object_table;
	Sales_Domain_Class_Map* class_map =
		new Sales_Domain_Class_Map();

	an_object_table.set_class_map(class_map);

	// Register the customer in the object table.
	// Save the object table to a file.
	mr_rubble.register_in_table(&an_object_table);
	an_object_table.save_to_file("tagFile.fmt");

	// Create another object table.
	Object_Table another_object_table;

	another_object_table.set_class_map(class_map);

	// Read the object from a file.
	another_object_table.read_from_file("tagFile.fmt");

	// Save the second table to another file.
	another_object_table.save_to_file("tagFile2.fmt");


	return 0;
}
