/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* TEST6.CPP                                                 */
/*************************************************************/

#ifndef SALES_H
#include "sales.h"
#endif

#ifndef TRN_VWS2_H
#include "trn_vws2.h"
#endif

int main ()
{
	 Sales_Transaction a_sale_transaction;
	 Line_Item a_line_item;
	 Line_Item* line_item1 =
		a_line_item.for_product_super_widget(5);
	 Line_Item* line_item2 =
		a_line_item.for_product_mega_widget(3);
	 Line_Item* line_item3 =
		a_line_item.for_product_bowling_shoes(1);

	 a_sale_transaction.connect_to_line_item(*line_item1);
	 a_sale_transaction.connect_to_line_item(*line_item2);
	 a_sale_transaction.connect_to_line_item(*line_item3);

	// Create a line item selection holder.
	Line_Item_Selection_Holder* line_item_holder =
		new Line_Item_Selection_Holder();

	line_item_holder->
		connect_to_transaction(a_sale_transaction);

	// Create a transaction container.
	Transaction_Container a_transaction_container;

	a_transaction_container.build_views();
	a_transaction_container.
		connect_menu_to_holder(*line_item_holder);

	// Tell it to change its displayed transaction.
	a_transaction_container.
		change_displayed_transaction(a_sale_transaction);
	return 0;

}