/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* TEST8.CPP                                                 */
/*************************************************************/

#ifndef SALES_H
#include "sales.h"
#endif

#ifndef TRN_VWS4_H
#include "trn_vws4.h"
#endif

int main ()
{
	// Create the customer.
	Customer a_customer;
	Customer mr_rubble = a_customer.customer_demo();

	// Create the selection holders.
	// Connect the transaction holder to the customer.
	Transaction_Selection_Holder* transaction_holder =
		new Transaction_Selection_Holder();

	transaction_holder->connect_to_customer(mr_rubble);

	Line_Item_Selection_Holder* line_item_holder =
		new Line_Item_Selection_Holder();

	// Create the customer container.
	Customer_Container* a_customer_container =
		new Customer_Container ();

	a_customer_container->build_views(mr_rubble);

	// Create the transction container.
	Transaction_Container* a_transaction_container =
		new Transaction_Container();

	a_transaction_container->build_views();

	// Connect the transaction console menu (inside a
	// customer container to the transaction selection
	// holder.
	a_customer_container->
		connect_menu_to_holder(*transaction_holder);

	// Connect the transaction selection holder to
	// the transaction container.
	transaction_holder->connect_to_transaction_container
		(*a_transaction_container);

	// Connect the line item console menu
	// (inside a transaction container) to the line item
	// selection holder.
	a_transaction_container->
		connect_menu_to_holder(*line_item_holder);

	a_customer_container->display_components();

	return 0;
}