/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* TRN_VWS1.CPP                                              */
/*************************************************************/

#ifndef TRN_VWS1_H
#include "trn_vws1.h"
#endif

//Transaction_Selection_Holder member functions

void Transaction_Selection_Holder::change_selection(int selection_index)
{
	// (List indeices start at zero).
	int list_selection = selection_index - 1;
	Transaction_List& transactions =
		a_customer->get_transactions();
	transaction_selection =
		transactions.item_at(list_selection);
}

void Line_Item_Selection_Holder::change_selection(int selection_index)
{
	int list_selection = selection_index - 1;
	Line_Item_List& line_items =
			a_transaction->get_line_items();
	line_item_selection =
		line_items.item_at(list_selection);
}

// Member functions for Transaction_Console_Menu

void Transaction_Console_Menu::make_items
	(Customer& a_customer)
{
	menu_size = 0;
	Transaction_List& transactions =
		a_customer.get_transactions();
	while(!transactions.end_of_list())
		{
		String transaction_description =
			transactions.current()->get_date_time();
		this->add_item(transaction_description);
		transactions++;
		}
	this->set_customer(a_customer);
}

void Transaction_Console_Menu::execute_selection()
{
	if (selection == 0)
		return;
	a_transaction_holder->change_selection(selection);
}

// Customer_Container member functions

void Customer_Container::make_name_box(Customer&
	a_customer)
{
	name_box = new Customer_Console_Display_Box();

	name_box->set_value_function(&Customer::get_name);
	name_box->set_label_string("Name:");
	name_box->set_object(a_customer);
}

void Customer_Container::make_address_box(Customer& a_customer)
{
	address_box = new Customer_Console_Display_Box();

	address_box->set_value_function(&Customer::get_address);
	address_box->set_label_string("Address: ");
	address_box->set_object(a_customer);
}

void Customer_Container
	::make_transaction_console_menu(Customer& a_customer)
{
	transaction_menu = new Transaction_Console_Menu();

	transaction_menu->make_items(a_customer);
	transaction_menu->add_terminator("Quit");
	transaction_menu->add_prompt("Select a transaction:  ");
}


void Customer_Container::build_views
	(Customer& a_customer)
{
	this->make_name_box(a_customer);
	this->make_address_box(a_customer);
	this->make_transaction_console_menu(a_customer);
}

void Customer_Container::connect_menu_to_holder
	(Transaction_Selection_Holder&
		a_transaction_holder)
{
	transaction_menu->
		connect_to_transaction_holder(a_transaction_holder);
}

void Customer_Container::display_customer_components()
{
	char* border = "-------------------------";

	cout << border << endl;
	name_box->display_value();
	cout << endl;
	address_box->display_value();
	cout << endl << border << endl;
}

void Customer_Container::display_components()
{
	this->display_customer_components();
	while(transaction_menu->get_user_selection() != 0)
		{
		transaction_menu->execute_selection();
		this->display_customer_components();
		}
}

