/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* STRING.H                                                  */
/*************************************************************/

#include <string.h>
#include <iostream.h>
#include "cc_boole.h"
#ifndef CC_STRING_H
#define CC_STRING_H

class String  {
public:

	// Constructors/destructors
	String() {character_array = new char[1];
			character_array[0] = '\0';}
	String(char* new_string);
	String(String& new_string);

	String(int integer_to_convert);
	String(float float_to_convert);

	~String() { }

	// Implementors
	int size() {return string_length;}
	String& copy();

	int as_integer();
	float as_float();

	String& read_up_to(char delimiter);
	String& break_at(char delimiter);
	Boolean contains_string(char* a_character_array);
	int locate_string(char* a_character_array);
	String& copy_sequence(int sequence_start, int sequence_end);

	// Operators

	String& operator+ (String& a_string);
	String& operator+= (String& a_string);
	String& operator= (String& a_string);
	String& operator= (const char* a_character_array);

	int operator<  (String& a_string);
	int operator>  (String& a_string);
	int operator== (String& a_string);

	operator char* () {return character_array; }
	friend ostream& operator<< (ostream& os, String& a_string);

private:

	char* character_array;
	int string_length;
};

#endif