/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* TEST5.CPP                                                 */
/*************************************************************/

#include <iostream.h>
#ifndef FLOW5_H
#include "flow5.h"
#endif

int main ()
{
	Lane lane_A("Lane A",25);
	Lane lane_B("Lane B", 35);

	lane_A.connect_to_crossing_lane(lane_B);
	lane_B.connect_to_crossing_lane(lane_A);
	lane_B.open();

	Step step_A(0, 2, 4);
	Step step_B(0, 3, 6);

	step_A.set_desired_flow_rate_to_max();
	step_B.set_desired_flow_rate_to_max();

	step_A.connect_to_lane(lane_A);
	step_B.connect_to_lane(lane_B);

	Script a_script;
	a_script.connect_to_step(step_A);
	a_script.connect_to_step(step_B);

	a_script.run_next_step();
	a_script.run_next_step();
	cout << endl << "Happy trails." << endl;

	return 0;
}