/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* TEST7.CPP                                                 */
/*************************************************************/

#include <iostream.h>
#include "flow6.h"
#ifndef TRAFVWS1_H
#include "trafvws1.h"
#endif


class Lane_View_Container
{
public:
	Lane_View_Container() { }
	~Lane_View_Container() { }

	Boolean is_open(Lane& a_lane)
		{ return (a_lane.get_current_flow_rate() > 0); }
	void display_components() { }
};


int main ()
{
	Display_Shape a_shape;
	Display_Color a_color;
	a_color.be_blue();
	a_shape.be_triangle();

	Rule open_rule = &Lane_View_Container::is_open;

	Lane lane_A("Lane A", 35);
	Lane_View_Container a_lane_view_container;
	Light_Box a_light_box(a_color, a_shape, open_rule);

	a_light_box.connect_to_lane(lane_A);
	a_light_box.connect_to_lane_view_container
		(a_lane_view_container);

	lane_A.open();
	cout << endl
		<< "Light box display when lane A is open: ";
	a_light_box.display_value();
	cout << endl;
	lane_A.close();
	cout << endl
		<< "Light box display when lane A is closed: ";
	a_light_box.display_value();

	return 0;
}

