/*************************************************************/
/* OBJECT-ORIENTED PROGRAMMING                               */
/* Peter Coad / Jill Nicola                                  */
/* Source Code Diskette                                      */
/* (c)1993  Object International, Inc.  All rights reserved. */
/*************************************************************/

/*************************************************************/
/* TRAFVWS1.CPP                                              */
/*************************************************************/

#ifndef TRAFVWS1_H
#include "trafvws1.h"
#endif

//Member functions for Display_Color

const space = ' ';

ostream& operator<< (ostream& os, Display_Color& display_color)
{
	os << display_color.get_name();
	return os;
}

Boolean Display_Color::operator== (Display_Color& display_color)
{
	return (name == display_color.get_name());
}

//Member functions for Display_Shape

ostream& operator<< (ostream& os, Display_Shape& display_shape)
{
	os << display_shape.get_name();
	return os;
}

Boolean Display_Shape::operator== (Display_Shape& display_shape)
{
	return (name == display_shape.get_name());
}

// Member functions for Light_Box

Light_Box::Light_Box()
{
	color = Display_Color("Red");
	shape = Display_Shape("Circle");
	location = 0;
}

Light_Box::Light_Box(Display_Color color_value,
			Display_Shape geometric_shape,
			Rule light_display_rule)
{
	color = color_value;
	shape = geometric_shape;
	display_rule = light_display_rule;
	location = 0;
}

// Initialization of static class members
// Display_Color Light_Box::background_color;

Boolean Light_Box::check_if_on()
{
	// Invoke the pointer to member function stored in
	// the display_rule data member
	Boolean result =
		(lane_view_container->*display_rule)(*lane);
	return result;
}
                                                
void Light_Box::display_value()
{
	if (!this->check_if_on())
		return;
	else
		{
		cout.width(location);
		String display = color.get_name() + String(" ")
			+ shape.get_name();
		cout << display;
		cout.width(0);
		}
}


ostream& operator<< (ostream& os, Light_Box& light_box)
{
	os << light_box.get_color() << "\t"
	   << light_box.get_shape() << "\t";
	return os;
}


void Light_Box::update_display()
{
//	lane_view_container->display_components();
}


