'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'CTVWCTR.ST'!

CompositePart subclass: #CountViewContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Count Views'!


!CountViewContainer methodsFor: 'view creation'!

addDecrementButtonOn: aCount 
	| button buttonArea |
	button := self
			makeButton: 'decrement'
			on: aCount
			for: #decrement.
	buttonArea := self constraintFrame: 1 /3 @ 0
				corner: 2 / 3 @ (1 / 3).
	self addView: button in: buttonArea!

addDisplayBoxOn: aCount
	| itemView itemArea |
	itemView := self makeDisplayBoxOn: aCount.
	itemArea := self constraintFrame: 1 / 3 @ (1 / 2)
			corner: 2 / 3 @ 1.
	self addView: itemView in: itemArea!

addIncrementButtonOn: aCount
	| button buttonArea |
	button := self
			makeButton: 'increment'
			on: aCount
			for: #increment.
	buttonArea := self constraintFrame: 0 @ 0
			corner: 1 / 3 @ (1 / 3).
	self addView: button in: buttonArea!

addResetButtonOn: aCount
	| button buttonArea |
	button := self
			makeButton: 'reset'
			on: aCount
			for: #reset.
	buttonArea := self constraintFrame: 2 /3 @ 0
			corner: 1 @ (1 / 3).
	self addView: button in: buttonArea! !

!CountViewContainer methodsFor: 'view layout'!

buildViewsOn: aCount
	self addDisplayBoxOn: aCount.
	self addIncrementButtonOn: aCount.
	self addDecrementButtonOn: aCount.
	self addResetButtonOn: aCount! !

!CountViewContainer methodsFor: 'view opening'!

openOn: aCount labeled: aLabel
	| win |
	self buildViewsOn: aCount.
	win := ScheduledWindow new.
	win component: self.
	win label: aLabel.
	win minimumSize: 250 @ 66.
	win open! !

!CountViewContainer methodsFor: 'private'!

addView: view in: area
	| wrapper |
	wrapper := BorderedWrapper on: view in: area.
	self addWrapper: wrapper!

constraintFrame: originConstraints corner: cornerConstraints
	^LayoutFrame originFractions: originConstraints
			cornerFractions: cornerConstraints!

makeButton: buttonLabel on: aCount for: action
	"Make a button to send a message to aCount to perform
	an action."

	| buttonView buttonAdaptor |
	buttonAdaptor := (PluggableAdaptor on: aCount)
				performAction: action.
	buttonView := LabeledBooleanView new.
	buttonView model: buttonAdaptor.
	buttonView label: buttonLabel.
	buttonView beTrigger.
	buttonView controller beTriggerOnUp.
	^buttonView!

makeDisplayBoxOn: aCount
	"Make a display box to display aCount's value. The display
	box will update when aCount sends a change message with
	the symbol, #value."

	| itemView |
	itemView := DisplayBox
			on: aCount
			aspect: #value
			change: nil
			menu: nil.
	^itemView! !