'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'SEQCOUNT.ST'!

Count subclass: #SequenceCount
	instanceVariableNames: 'sequence position '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Counts'!


!SequenceCount methodsFor: 'initialize-release'!

initialize
	"Initialize the sequence and the sequence pointer. 
	I can't initialize my resetValue because the sequence is 
	empty"

	position := 1.
	sequence := OrderedCollection new.
	super initialize!

initializeResetValue
	sequence isEmpty ifTrue: [^nil].
	resetValue := sequence first.
	self reset! !

!SequenceCount methodsFor: 'counting'!

decrement
	"If my sequence is empty, don't do anytihng. 
	Otherwise, back up my index pointer. 
	Don't go past the first item in the sequence."

	sequence isEmpty ifTrue: [^self].
	position := position - 1 max: 1.
	self value: (sequence at: position)!

increment
	"If my sequence is empty, don't do anytihng.
	Otherwise, advance my index pointer. 
	Don't go past the last item in the sequence."

	sequence isEmpty ifTrue: [^self].
	position := position + 1 min: sequence size.
	self value: (sequence at: position)!

reset
	"Reset my index pointer, then perform my generalization's 
	reset method."

	position := 1.
	super reset! !

!SequenceCount methodsFor: 'sequence accessing'!

setSequence: aCollection 
	"Set my sequence to aCollection. 
	Now I can initialize my resetValue"

	sequence := aCollection.
	self initializeResetValue! !