'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'CSHDVC.ST'!

Model subclass: #CashDevice
	instanceVariableNames: 'amountCollected '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Vending'!


!CashDevice methodsFor: 'initialize-release'!

initialize
	amountCollected := 0.! !

!CashDevice methodsFor: 'accessing'!

amountCollected	
	 "Return the current value of amount collected " 

	^amountCollected!

amountCollected: newValue 
	"Set the value of amount collected.
	 Notify my dependents that I've changed"

	amountCollected := newValue.
	self changed: #amountCollected! !

!CashDevice methodsFor: 'cash collecting'!

gotEnough: amountToCollect 
	"Return true if the amount collected is greater than or 
	equal to the amount to be collected."

	^ amountCollected >= amountToCollect!

makeChangeFor: aPrice
	self amountCollected:  amountCollected - aPrice!

return
	"Reset the cash collected. 
	Return false to indicate cash not collected"

	self amountCollected: 0.
	^false! !

!CashDevice methodsFor: 'simulating'!

addCash
	"Increase my amount collected by some default increment."

	self amountCollected: (amountCollected + 
		self cashIncrement)!

cashIncrement
	^0.25! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CashDevice class
	instanceVariableNames: ''!


!CashDevice class methodsFor: 'instance creation'!

new
	^super new initialize! !