'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'CSHVWCTR.ST'!

ModelValueViewContainer subclass: #CashDeviceViewContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Vending Views'!


!CashDeviceViewContainer methodsFor: 'view creation'!

buildViewOn: aMoneyDevice 

	self addValueViewOn: aMoneyDevice.
	self addIncrementButtonOn: aMoneyDevice.
	self addReturnButtonOn: aMoneyDevice.! !

!CashDeviceViewContainer methodsFor: 'view layout'!

addIncrementButtonOn: aCashDevice 
	| button buttonArea |
	button := self
			makeButton: 'Add Cash'
			on: aCashDevice
			for: #addCash.
	buttonArea := self constraintFrame: 2 /3 @ 0
				corner: 1 @ (1 / 2).
	self addView: button in: buttonArea!

addReturnButtonOn: aCashDevice
	| button buttonArea |
	button := self
			makeButton: 'Return'
			on: aCashDevice
			for: #return.
	buttonArea := self constraintFrame: 2 /3 @ (1 / 2)
				corner: 1 @ 1.
	self addView: button in: buttonArea!

addValueViewOn: aMoneyDevice
	| itemView itemArea |
	itemView := self makeDisplayBoxOn: aMoneyDevice
				for: #amountCollected.
	itemArea := self constraintFrame: 0 @ 1 / 3
				corner: 2 / 3 @ 2 / 3.
	self addView: itemView in: itemArea! !

!CashDeviceViewContainer methodsFor: 'window opening'!

windowLabel
	^'Cash Device'!

windowSize
	^250 @ 50  "pixels"! !