'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'MDLVALVW.ST'!

CompositePart subclass: #ModelValueViewContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Model Views'!


!ModelValueViewContainer methodsFor: 'view layout'!

addView: view in: area 
	| wrapper |
	wrapper := BorderedWrapper on: view in: area.
	self addWrapper: wrapper! !

!ModelValueViewContainer methodsFor: 'view creation'!

makeButton: buttonLabel on: aModel for: action 
	"Make a button to send a message to aModel
	to perform an action"

	| buttonView buttonAdaptor |
	buttonAdaptor := (PluggableAdaptor on: aModel)
				performAction: action.
	buttonView := LabeledBooleanView new.
	buttonView model: buttonAdaptor.
	buttonView label: buttonLabel.
	buttonView beTrigger.
	buttonView controller beTriggerOnUp.
	^buttonView!

makeDisplayBoxOn: aModel for: aspect
	"Make a display box that displays that value indicated
	by aspect, but has no message by which it can change a
	value"

	| itemView |
	itemView := DisplayBox
			on: aModel
			aspect: aspect
			change: nil
			menu: nil.
	^itemView! !

!ModelValueViewContainer methodsFor: 'window opening'!

openOn: aModel
	"Build the views for the model inside me.
	Place myself in a window with my default label.
	Open the window on the screen."

	self openOn: aModel
		labeled: self windowLabel!

openOn: aModel labeled: aLabel
	"Build the views for the model inside me.
	Place myself in a window with my default label.
	Open the window on the screen."

	| window |
	window := ScheduledWindow new.
	window component: self.
	self buildViewOn: aModel.
	window label: aLabel.
	window minimumSize: self windowSize.
	window open!

windowLabel
	^'Model Value'!

windowSize
	^100 @ 100  "pixels"! !

!ModelValueViewContainer methodsFor: 'private'!

constraintFrame: originConstraints corner: cornerConstraints
	^LayoutFrame originFractions: originConstraints
			   cornerFractions: cornerConstraints! !