'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'CLASSMAP.ST'!

Object subclass: #ClassMap
	instanceVariableNames: 'classFormats '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Transaction Formats'!


!ClassMap methodsFor: 'initialize-release'!

initialize
	classFormats := Dictionary new! !

!ClassMap methodsFor: 'accessing'!

classFormats	
	 "- 26 September 1992   12:15:28 pm -" 
	 "Return the current value of classFormats " 

	^classFormats!

classFormats:  newValue
	 "- 26 September 1992   12:15:28 pm -" 
	 "Set the  value of classFormats " 

	classFormats :=  newValue! !

!ClassMap methodsFor: 'mapping'!

getFormatFor: className 
	 ^classFormats at: className ifAbsent: []!

putFormat: formatObject at: className 
	^classFormats at: className put: formatObject! !

!ClassMap methodsFor: 'restoring'!

makeObjectInClass: objectClassNameString 
	| objectClassSymbol objectClass |
	objectClassSymbol := objectClassNameString asSymbol.
	objectClass := Smalltalk at: objectClassSymbol 
		ifAbsent: [nil].
	^objectClass isNil
		ifTrue: [nil]
		ifFalse: [objectClass restore]! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClassMap class
	instanceVariableNames: ''!


!ClassMap class methodsFor: 'instance creation'!

new
	^super new initialize! !

!ClassMap class methodsFor: 'defaults'!

salesClassMap
	| newOne |
	newOne := self new.
	newOne putFormat: CustomerFormat new at: Customer name.
	newOne putFormat: SalesTransactionFormat new 
		at: SalesTransaction name.
	newOne putFormat: LineItemFormat new 
		at: LineItem name.
	newOne putFormat: ProductFormat new at: Product name.
	newOne putFormat: ObjectTableFormat new at: ObjectTable 
		name.
	^newOne! !