'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'CSTMRCTR.ST'!

ModelCollectionViewContainer subclass: #CustomerContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Transaction Views'!


!CustomerContainer methodsFor: 'view creation'!

buildViewOn: aCustomer

	self addNameViewOn: aCustomer.
	self addAddressViewOn: aCustomer.
	self addTransactionListViewOn: aCustomer! !

!CustomerContainer methodsFor: 'view layout'!

addAddressViewOn: aCustomer 
	| itemView itemArea |
	itemView := self makeDisplayBoxOn: aCustomer 
		for: #address.
	itemArea := self constraintFrame: 0 @ (1 / 9) 
		corner: 1 @ (2 / 9).
	self addView: itemView in: itemArea!

addNameViewOn: aCustomer 
	| itemView itemArea |
	itemView := self makeDisplayBoxOn: aCustomer for: #name.
	itemArea := self constraintFrame: 0 @ 0 corner: 1 @ (1 / 9).
	self addView: itemView in: itemArea!

addTransactionListViewOn: customer
	| itemView itemArea  |
	itemView := self
			makeListOn: customer
			showing: #transactionCollection
			selecting: #changeTransactionSelection:
			updateFor: #transactions.
	itemArea := self constraintFrame: 0 @ (2 / 9) corner: 1 @ (1).
	self addListView: itemView in: itemArea! !