'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'CSTMRFMT.ST'!

PDCObjectTagFormat subclass: #CustomerFormat
	instanceVariableNames: 'transactionIDs '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Transaction Formats'!


!CustomerFormat methodsFor: 'storing'!

storeAttributesFor: customer on: stream 
	self
		storeTag: 'name'
		value: customer name
		on: stream.
	self
		storeTag: 'address'
		value: customer address
		on: stream!

storeConnectionsFor: customer on: stream 
	customer transactions
		do:
			[:transaction |
			self storeTag: 'transaction' on: stream.
			self storeID: transaction objectID on: stream]! !

!CustomerFormat methodsFor: 'restoring'!

restoreAttributesFor: customer from: stream
	| customerName customerAddress |
	customerName := self restoreTagValue: 'name'
		from: stream.
	customer name: customerName.
	customerAddress := self restoreTagValue: 'address'
		from: stream.
	customer address: customerAddress!

restoreConnectionsFor: customer from: stream using: objectTable
	[(self restoreTag: 'transaction' from: stream) isNil
		or: [stream atEnd]]
		whileFalse:
			[| transactionID transaction |
			transactionID := self restoreIDFrom: stream.
			transactionID isNil ifTrue: [^self].
			transaction := objectTable objectAt: transactionID.
			transaction isNil
				ifFalse: [customer connectToTransaction:
						transaction]]! !