'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'CSTMRWIN.ST'!

CompositePart subclass: #CustomerWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Transaction Views'!


!CustomerWindow methodsFor: 'view creation'!

buildViewOn: aCustomer 
	| transaction lineItem transactionSelectionHolder
		lineItemSelectionHolder |
	transaction := aCustomer transactions first.
	lineItem := transaction lineItems first.
	transactionSelectionHolder := aCustomer transactionSelection.
	lineItemSelectionHolder := transaction lineItemSelection.
	self addCustomerContainer: aCustomer.
	self addTransactionContainer: transaction
		and: transactionSelectionHolder
		and: lineItemSelectionHolder.
	self addLineItemContainer: lineItem and:
		lineItemSelectionHolder! !

!CustomerWindow methodsFor: 'view layout'!

addCustomerContainer: customer
	| customerView  frame |
	customerView := CustomerContainer new.
	customerView buildViewOn: customer .
	frame := self constraintFrame: 0 @ 0 corner: 1 / 2 @ 1.
	self addView: customerView in: frame.
	^customerView!

addLineItemContainer: lineItem and: lineItemHolder
	| lineItemContainer  frame |
	lineItemContainer := LineItemContainer new.
	lineItemContainer buildViewOn: lineItem.
	lineItemHolder connectToLineItemContainer:
		lineItemContainer.
	frame := self constraintFrame: 1 / 2 @ (7 / 9)
		corner: 1 @ 1.
	self addView: lineItemContainer in: frame.
	^lineItemContainer!

addTransactionContainer: transaction and: transactionSelectionHolder
and: lineItemSelectionHolder
	| transactionContainer frame |
	transactionContainer := TransactionContainer new.
	transactionContainer buildViewOn: transaction.
	transactionSelectionHolder
		connectToTransactionContainer: transactionContainer.
	transactionContainer
		connectToLineItemSelectionHolder:
			lineItemSelectionHolder.
	frame := self constraintFrame: 1 / 2 @ 0 corner: 1 @ (7 / 9).
	self addView: transactionContainer in: frame.
	^transactionContainer! !

!CustomerWindow methodsFor: 'window opening'!

openOn: aCustomer

	| window |
	window := ScheduledWindow new.
	window component: self.
	self buildViewOn: aCustomer.
	window label: 'Customer demo'.
	window minimumSize: 300@200.
	window model: aCustomer.
	window open! !

!CustomerWindow methodsFor: 'private'!

addView: view in: area
	| wrapper |
	wrapper := BoundedWrapper on: view in: area.
	self addWrapper: wrapper!

constraintFrame: originConstraints corner: cornerConstraints
	^LayoutFrame originFractions: originConstraints
			   cornerFractions: cornerConstraints! !