'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'LNITMCTR.ST'!

ModelValueViewContainer subclass: #LineItemContainer
	instanceVariableNames: 'totalBox quantityBox '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Transaction Views'!


!LineItemContainer methodsFor: 'view creation'!

buildViewOn: aLineItem 
	self addQuantityBoxOn: aLineItem.
	self addTotalBoxOn: aLineItem! !

!LineItemContainer methodsFor: 'view layout'!

addQuantityBoxOn: lineItem 
	|  itemArea |
	quantityBox := self makeDisplayBoxOn: lineItem for: #quantity.
	itemArea := self constraintFrame: 0 @ 0 corner: 1 @ (1 / 2).
	self addView: quantityBox in: itemArea.
	^quantityBox!

addTotalBoxOn: lineItem 
	|  itemArea |
	totalBox := self makeDisplayBoxOn: lineItem 
		for: #calculateTotal.
	itemArea := self constraintFrame: 0 @ (1 / 2) 
		corner: 1 @ 1.
	self addView: totalBox in: itemArea.
	^totalBox! !

!LineItemContainer methodsFor: 'view selections'!

changeDisplayedLineItem: selectedLineItem
	selectedLineItem isNil ifTrue: [^self].
	totalBox model: selectedLineItem.
	quantityBox model: selectedLineItem.
	totalBox update: #calculateTotal.
	quantityBox update: #quantity! !