'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'LNITMFMT.ST'!

PDCObjectTagFormat subclass: #LineItemFormat
	instanceVariableNames: 'productID '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Transaction Formats'!


!LineItemFormat methodsFor: 'storing'!

storeAttributesFor: lineItem on: stream
	self
		storeTag: 'line number'
		value: lineItem lineNumber printString
		on: stream.
	self
		storeTag: 'item quantity'
		value: lineItem quantity printString
		on: stream!

storeConnectionsFor: lineItem on: stream 
	productID := lineItem product objectID.
	self storeTag: 'product' on: stream.
	self storeID:  productID on: stream! !

!LineItemFormat methodsFor: 'restoring'!

restoreAttributesFor: transactionLineItem from: stream 
	| numberString |
	numberString := self restoreTagValue: 'line number'
				from: stream.
	numberString isNil
		ifFalse: [transactionLineItem lineNumber:
				(Integer readFrom:
					numberString readStream)].
	numberString := self restoreTagValue: 'item quantity'
				from: stream.
	numberString isNil
		ifFalse: [transactionLineItem quantity:
				 (Integer readFrom:
					numberString readStream)]!

restoreConnectionsFor: lineItem from: stream using: objectTable
	|  objectID product |
	self restoreTag: 'product' from: stream.
	objectID := self restoreIDFrom: stream.
	objectID isNil ifTrue: [^self].
	product := objectTable objectAt: objectID.
	lineItem connectToProduct: product! !