'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'OBTBLFMT.ST'!

ObjectTagFormat subclass: #ObjectTableFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Transaction Formats'!


!ObjectTableFormat methodsFor: 'storing'!

store: objectTable on: stream 
	self storeDefnStartOn: stream.
	self storeClassNameFor: objectTable on: stream.
	self storeTableStartOn: stream.
	self storeObjectIDsFor: objectTable on: stream.
	self storeTableEndOn: stream.
	self storeDefnEndOn: stream!

storeAttributesFor: objectTable on: stream 
	^self!

storeObjectIDsFor: objectTable on: stream 
	objectTable objects
		do: 
			[:pdcObject | 
			| objectFormat |
			objectFormat := pdcObject getFormatFrom: 
					objectTable classMap.
			objectFormat storeClassNameFor: pdcObject
					on: stream.
			objectFormat storeObjectIDFor: pdcObject
					on: stream].!

storeTableEndOn: stream
	self storeTag: '\ObjectTable' on: stream.
	stream cr.!

storeTableStartOn: stream
	self storeTag: 'ObjectTable' on: stream.
	stream cr.! !

!ObjectTableFormat methodsFor: 'restoring'!

readTableEndFrom: stream
	self restoreTag: '\ObjectTable' from: stream.
	stream atEnd ifFalse: [stream next]!

readTableStartFrom: stream
	self restoreTag: 'ObjectTable' from: stream.
	stream atEnd ifFalse: [stream next].!

restore: objectTable from: stream
	self readDefnStartFrom: stream.
	self restoreClassNameFrom: stream.
	self readTableStartFrom: stream.
	self restoreObjectIDsFor: objectTable from: stream.
	self readTableEndFrom: stream.
	self readDefnEndFrom: stream!

restoreAttributesFor: objectTable from: stream
	^self!

restoreObjectIDsFor: objectTable from: stream
	|  className newOne objectFormat |
	[stream atEnd]
		whileFalse:
			[className := self
					restoreClassNameFrom: stream.
			className isNil ifTrue:
				[^self ].
			newOne := objectTable createObject: className.
			objectFormat := newOne getFormatFrom:
						objectTable classMap.
			(objectFormat restoreObjectIDFor: newOne
					from: stream) isNil
				ifTrue: [^self].
			objectTable registerObject: newOne
				at: newOne objectID]! !