'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'PDCOBFMT.ST'!

ObjectTagFormat subclass: #PDCObjectTagFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Transaction Formats'!


!PDCObjectTagFormat methodsFor: 'storing'!

store: pdcObject on: stream
	self storeDefnStartOn: stream.
	self storeClassNameFor: pdcObject on: stream.
	self storeObjectIDFor: pdcObject on: stream.
	self storeAttributesFor: pdcObject on: stream.
	self storeConnectionsFor: pdcObject on: stream.
	self storeDefnEndOn: stream!

storeObjectIDFor: pdcObject on: stream 
	self storeTag: 'objectID' on: stream.
	self storeID: pdcObject objectID on: stream! !

!PDCObjectTagFormat methodsFor: 'restoring'!

restore: pdcObject from: stream using: objectTable 
	self readDefnStartFrom: stream.
	self restoreClassNameFrom: stream.
	self restoreObjectIDFor: pdcObject from: stream.
	self restoreAttributesFor: pdcObject from: stream.
	self restoreConnectionsFor: pdcObject
		from: stream using: objectTable.
	self readDefnEndFrom: stream!

restoreObjectIDFor: pdcObject from: stream 
	|  objectID |
	(self restoreTag: 'objectID' from: stream) isNil ifTrue:
		 [^nil].
	objectID:= (self restoreIDFrom: stream).
	objectID isNil ifTrue: [^nil].
	pdcObject objectID: objectID! !

!PDCObjectTagFormat methodsFor: 'storing-private'!

storeID: id on: stream 
	self
		storeTag: 'id'
		value: id printString
		on: stream! !

!PDCObjectTagFormat methodsFor: 'restoring-private'!

restoreIDFrom: stream 
	| idString |
	idString := self restoreTagValue: 'id' from: stream.
	idString isNil ifTrue: [^nil].
	^Integer readFrom: idString readStream! !