'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'TRANSCTR.ST'!

ModelCollectionViewContainer subclass: #TransactionContainer
	instanceVariableNames: 'lineItemSelectionHolder
		lineItemList totalBox '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Transaction Views'!


!TransactionContainer methodsFor: 'view layout'!

addLineItemListOn: transaction
	|  listArea  |
	lineItemList := self
			makeListOn: transaction
			showing: #lineItemCollection
			selecting: #changeLineItemSelection:
			updateFor: #lineItems.
	listArea := self constraintFrame: 0 @ (1 / 3) corner: 1 @ 1.
	self addListView: lineItemList in: listArea.
	^lineItemList!

addTotalBoxOn: transaction
	|  itemArea |
	totalBox := self makeDisplayBoxOn: transaction
		for: #calculateTotal.
	itemArea := self constraintFrame: 0 @ (1 / 9)
			corner: 1 @ (2 / 9).
	self addView: totalBox in: itemArea.
	^totalBox! !

!TransactionContainer methodsFor: 'view creation'!

buildViewOn: transaction
	self addLineItemListOn: transaction.
	self addTotalBoxOn: transaction! !

!TransactionContainer methodsFor: 'view selections'!

changeDisplayedTransaction: selectedTransaction
	selectedTransaction isNil ifTrue: [^self].
	lineItemList  model: selectedTransaction.
	totalBox model: selectedTransaction.
	lineItemList update: #lineItems.
	totalBox update: #calculateTotal.
	selectedTransaction lineItemSelection: 
		lineItemSelectionHolder.! !

!TransactionContainer methodsFor: 'connections'!

connectToLineItemSelectionHolder: aLineItemSelectionHolder
	lineItemSelectionHolder := aLineItemSelectionHolder!

lineItemSelectionHolder
	^lineItemSelectionHolder! !