'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'TRANSFMT.ST'!

PDCObjectTagFormat subclass: #TransactionFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Transaction Formats'!


!TransactionFormat methodsFor: 'storing'!

storeAttributesFor: transaction on: stream 
	self
		storeTag: 'dateTime'
		value: transaction dateTime
		on: stream!

storeConnectionsFor: transaction on: stream 
	transaction lineItems
		do: 
			[:anItem | 
			self storeTag: 'lineItem' on: stream.
			self storeID: anItem objectID on: stream]! !

!TransactionFormat methodsFor: 'restoring'!

restoreAttributesFor: transaction from: stream 
	| dateTime |
	dateTime := self restoreTagValue: 'dateTime' from: 
		stream.
	transaction dateTime: dateTime!

restoreConnectionsFor: transaction from: stream using: objectTable 
	[(self restoreTag: 'lineItem' from: stream) isNil 
		or: [stream atEnd]]
		whileFalse: 
			[| lineItemID lineItem |
			lineItemID := self restoreIDFrom: stream.
			lineItemID isNil ifTrue: [^self].
			lineItem := objectTable objectAt: lineItemID.
			lineItem isNil
				ifFalse: [transaction
						connectToLineItem:
							lineItem]]! !