'OBJECT-ORIENTED PROGRAMMING
Peter Coad / Jill Nicola
Source Code Diskette
(C) 1993  Object International, Inc.  All rights reserved.
'!

'LIGHTBOX.ST'!

View subclass: #LightBox
	instanceVariableNames: 'color shape displayRule '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Traffic-Views'!


!LightBox methodsFor: 'initialize-release'!

initialize
	color := ColorValue black.
	displayRule := [:m | true].
	self beCircle: 20@20 radius: 15! !

!LightBox methodsFor: 'accessing'!

color	
	 "Return the current value of color "

	^color!

color:  newValue
	 "Set the  value of color "

	color :=  newValue!

color: colorValue displayRule: ruleBlock
	color := colorValue.
	displayRule := ruleBlock!

displayRule
	 "Return the current value of displayRule "

	^displayRule!

displayRule:  newValue
	 "Set the  value of displayRule "

	displayRule :=  newValue!

shape
	 "Return the current value of shape "

	^shape!

shape:  newValue
	 "Set the  value of shape "

	shape :=  newValue! !

!LightBox methodsFor: 'displaying'!

displayColor
	^self checkIfOn
		ifTrue: [self color]
		ifFalse: [self graphicsContext medium
			backgroundColor]!

displayOn: graphicsContext 
	self displayOn: graphicsContext color: self displayColor!

displayOn: graphicsContext color: displayColor
	graphicsContext paint: displayColor.
	shape displayFilledOn: graphicsContext!

displayValue
	self displayOn: self  graphicsContext! !

!LightBox methodsFor: 'shapes'!

beCircle: center radius: radius
	shape := Circle center: center radius: radius!

beEllipse: center majorAxis: horizAxis minorAxis: vertAxis
	| halfHeight halfWidth origin corner |
	halfHeight := vertAxis // 2.
	halfWidth := horizAxis // 2.
	origin := center x - halfWidth @ (center y - halfHeight).
	corner := center x + halfWidth @ (center y + halfHeight).
	shape := EllipticalArc boundingBox: (origin corner: corner)!

bePloygon: vertices
	shape := Polyline vertices: vertices!

beRectangle: origin corner: corner 
	shape := Rectangle origin: origin corner: corner!

beSquare: origin length: sideLength 
	| corner |
	corner := origin x + sideLength @ (origin y + 
		sideLength).
	self beRectangle: origin corner: corner! !

!LightBox methodsFor: 'testing'!

checkIfOn
	"Execute my rule for my model."

	^displayRule value: model! !

!LightBox methodsFor: 'updating'!

update: aspectChanged 
	"My model has changed. 
	Update my display"

	self displayValue! !